           (*-------------------------------------------*
            |                CSP-Prover                 |
            |               February 2005               |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Test_Lfp = CSP_Prover:

(*****************************************************************

         1. Test Least Fixed Point
         2. 
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                         event
 *********************************************************)

datatype Event = act nat
datatype Name1 = UG1 nat
datatype Name2 = UG2 nat

(*********************************************************
            specification SPC and system SYS
 *********************************************************)

consts 
  Def1 :: "(Name1, Event) procDF"
  Def2 :: "(Name2, Event) procDF"

primrec
  "Def1       (UG1 n) = <UG1 (Suc n)> |~| (act n -> STOP)"

primrec
  "Def2       (UG2 n) = <UG2 (Suc n)> [+] (act (n * 2) -> STOP)"

consts 
  SPC1 :: "(Name1, Event) procRC"
  SPC2 :: "(Name2, Event) procRC"

defs
  SPC1_def: "SPC1 == LET:Lfp Def1 IN <UG1 0>"
  SPC2_def: "SPC2 == LET:Lfp Def2 IN <UG2 0>"

(*********************************************************
            relation between SPC and SYS
 *********************************************************)

consts 
  SPC2_to_SPC1 :: "Name2 => (Name1, Event) proc"

primrec
  "SPC2_to_SPC1 (UG2 n) = <UG1 (n * 2)>"

(*********************************************************
                   ? SPC1 <=F SPC2 ?
 *********************************************************)

lemma "SPC1 <=F SPC2"
apply (simp add: SPC1_def SPC2_def)

  (***** by fixed point induction *****)
apply (rule csp_fp_induct_cpo[of _ _ _ "SPC2_to_SPC1"], simp)
apply (induct_tac C)
apply (tactic {* csp_unwind_cpo_left_tac 1 *})
apply (tactic {* csp_unwind_cpo_left_tac 1 *})

apply (rule csp_Int_choice_left3)
apply (rule csp_decompo)
apply (rule csp_Int_choice_left1)
by (simp_all)

end
